package com.ahuntsic.outils;

/**
 * MaDate.java
 * hrite de java.util.Date et ajoute certaines fonctionnalits
 * Date: 07/10/2005
 * Pour: Mr. Mohammed Salah Bendelloul
 * Projet: Travail pratique #2
 *
 * @author Hassen Ben Tanfous
 */

//imports
import java.util.*;
import java.text.*;
import java.io.*;

public class MaDate extends Date { //implements Serializable
    private DecimalFormat formateDate;
    private MonStringTokenizer chaineJetons;

    /**
     * configure l'anne, le mois et le jour d'une date
     * @param annee int
     * @param mois int
     * @param jours int
     */
    public MaDate(int annee, int mois, int jours) {
        setYear(annee);
        setMonth(mois);
        setDate(jours);

        formateDate = new DecimalFormat("00");
    }

    /**
     * permet d'initialiser une date  partir d'une date sous le format
     * aaaa/mm/jj
     * @param date String
     */
    public MaDate(String date) {
        formateDate = new DecimalFormat ("00");
        chaineJetons = new MonStringTokenizer(date, "/");
        setYear(Integer.parseInt(chaineJetons.nextJeton()));
        setMonth(Integer.parseInt(chaineJetons.nextJeton()));
        setDate(Integer.parseInt(chaineJetons.nextJeton()));

    }

    public String toString() {
        return getYear() + "/" + formateDate.format(getMonth()) + "/" +
                formateDate.format(getDate());
    }
} //Fin de la classe Date
