package com.ahuntsic.outils;

/**
 * Salaire.java
 * permet de configurer la date de dbut de l'Employ, son salaire et la
 * raison d'affectation
 * Date: 07/10/2005
 * Pour: Mr. Mohammed Salah Bendelloul
 * Projet: Travail pratique #2
 *
 * @author Hassen Ben Tanfous
 */
import java.io.*;
public class Salaire implements Serializable
{

    //les 4 raisons d'affectation du salaire
    /** raison d'affectation: engagement */
    public static final int ENGAGEMENT = 10;

    /** raison d'affectation: transfert */
    public static final int TRANSFERT = 20;

    /** raison d'affectation: promotion */
    public static final int PROMOTION = 30;

    /** raison d'affectation: dpart */
    public static final int DEPART = 50;

    //la date de dbut
    private MaDate dateDebut;

    private double salaire;

    private int raison;

    /**
     * configure le salaire d'un employ avec les paramtres passs
     * @param dateDebut MaDate
     * @param salaire double
     * @param raison int
     */
    public Salaire(MaDate dateDebut, double salaire, int raison) {
        this.dateDebut = dateDebut;
        this.salaire = salaire;
        this.raison = raison;
    }

    public MaDate getDateDebut() {
        return dateDebut;
    }

    public double getSalaire() {
        return salaire;
    }

    public int getRaison() {
        return raison;
    }
} //Fin de la classe Salaire
